function b = spline_basis(s);
% base function for cubic splines in 1D
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

b = zeros(size(s));

dom1 = find((s>=-2)&(s<-1));
b(dom1) = 1/6*(2+s(dom1)).^3;

dom2 = find((s>=-1)&(s<-0));
b(dom2) = -1/2*s(dom2).^3-s(dom2).^2 + 2/3;

dom3 = find((s>=0)&(s<1));
b(dom3) = 1/2*s(dom3).^3-s(dom3).^2+2/3;

dom4 = find((s>=1)&(s<2));
b(dom4) = 1/6*(2-s(dom4)).^3;