% script file splines1.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc; clear all; close all;

% generate interpolation points
a = 0; b = 1; n = 13;

x = linspace(a,b,n)';
h = x(2)-x(1);

f = [20 30 33 42 45 32 24 23 7 13 22 17 19]';
f = [1; f; 0]; % set some derivative values at the ends

% set the matrix A
main_diag = ones(n+2,1);
A = spdiags([1/6*main_diag 2/3*main_diag 1/6*main_diag],[-1 0 1],(n+2),(n+2));
% rewrite the first and last rows corresponding to derivatives
A(1,1) = -1/2/h; A(1,2) = 0; A(1,3) = 1/2/h;
A(n+2,n) = -1/2/h; A(n+2,n+1) = 0; A(n+2,n+2) = 1/2/h;

U = A\f; % solve the system

% visualise the solution
t = linspace(a,b,200);

u = zeros(size(t));

psi = spline_basis((t-(-h))/h);
u = u + U(1)*psi; % add the first entry

for i=1:n
  psi = spline_basis((t-x(i))/h);
  u = u+U(i+1)*psi; % add the next coefficient*basis function
end

psi = spline_basis((t-(b+h))/h);
u = u + U(n+2)*psi; % add the last entry

plot(t,u,'b',x,f(2:n+1),'r*');
hold on; grid on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% mark the values at the middle points
xx = x(1:n-1)+h/2;

u = zeros(size(xx));

psi = spline_basis((xx-(-h))/h);
u = u + U(1)*psi;

for i=1:n
  psi = spline_basis((xx-x(i))/h);
  u = u+U(i+1)*psi;
end

psi = spline_basis((xx-(b+h))/h);
u = u + U(n+2)*psi;

plot(xx,u,'g*');

  